
function CreateGrants()
	CreateRecycleGrant()
	CreateGarden()
	CreateGardenProduction()
end

function CreateRecycleGrant()
	Objective.CreateGrant			( "Grant_Recycle", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Cleaning", 0 )
    Objective.HiddenWhileLocked     ()

	Objective.CreateGrant			( "Grant_Recycle_Research", 0, 0 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.Requires				( "Unlocked", "GarbageRecycling", 0 )
	
	Objective.CreateGrant			( "Grant_Recycle_Requirement1", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireRoom			( "Recycling", true )

	Objective.CreateGrant			( "Grant_Recycle_Requirement2", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireObjects		( "RecycleDesk", 1 )
	
	Objective.CreateGrant			( "Grant_Recycle_Requirement3", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireObjects		( "TrashBin10", 1 )
	
	Objective.CreateGrant			( "Grant_Recycle_Requirement4", 0, 500 )
	Objective.SetParent				( "Grant_Recycle" )
	Objective.RequireObjects		( "TrashCompactor", 1 )
end

function CreateGarden()
	Objective.CreateGrant			( "Grant_Garden", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "GroundsKeeping", 0 )
    Objective.HiddenWhileLocked     ()
		
	Objective.CreateGrant			( "Grant_Garden_Research", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.Requires				( "Unlocked", "Gardening", 0 )
	
	Objective.CreateGrant			( "Grant_Garden_GardenRoom", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.RequireRoom			( "Garden", true )
	
	Objective.CreateGrant			( "Grant_Garden_GardenControlNumber", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.RequireObjects		( "GardenPlantControl", 1 )
	
	Objective.CreateGrant			( "Grant_Garden_GardenPotNumber", 0, 0 )
	Objective.SetParent				( "Grant_Garden" )
	Objective.RequireObjects		( "GardenPot2Remote", 8 )
end

function CreateGardenProduction()
	Objective.CreateGrant			( "Grant_Garden_Production", 1500, 2500 )
	Objective.SetPreRequisite		( "Unlocked", "Gardening", 0 )
    Objective.HiddenWhileLocked     ()
	
	Objective.CreateGrant			( "Grant_Garden_Production_Research", 0, 0 )
	Objective.SetParent				( "Grant_Garden_Production" )
	Objective.Requires				( "Completed", "Grant_Garden", 0 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_ProgramPassed", 0, 0 )
	Objective.SetParent				( "Grant_Garden_Production" )
	Objective.Requires				( "ReformPassed", "PlantCultivation", 2 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenAssigned", 0, 0 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.Requires				( "PrisonerJobs", "Garden", 2 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenTomatoProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects	 	( "GardenTomato", 11 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenCucumberProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects 		( "GardenCucumber", 11 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenRoseProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects	 	( "GardenRose", 11 )
	
	Objective.CreateGrant			( "Grant_Garden_Production_GardenLilyProduction", 0, 5000 )
	Objective.SetParent				( "Grant_Garden_Production")
	Objective.RequireObjects 		( "GardenLily", 11 )
end
