
local timeTot=0
local timeInit = 0
local initTimer = math.random(1,5) / 0.75
local Now = 0
local StartingMinute = 0
local maxAge = 24		-- 24 game hours
local Get = Object.GetProperty
local Set = Object.SetProperty
local CurrentHour = math.floor(math.mod(World.TimeIndex,1440) /60)
local CurrentMinute = math.floor(math.mod(World.TimeIndex,60))
local myHarvestHour = 0		-- set to 0 (midnight) (=disabled)
local myTimeWarpFactor = 1
local HourToHarvest = { [0] = "disabled", [1] = "01:00", [2] = "02:00", [3] = "03:00", [4] = "04:00", [5] = "05:00", [6] = "06:00", [7] = "07:00", [8] = "08:00", [9] = "09:00", [10] = "10:00", [11] = "11:00", [12] = "12:00", [13] = "13:00", [14] = "14:00", [15] = "15:00", [16] = "16:00", [17] = "17:00", [18] = "18:00", [19] = "19:00", [20] = "20:00", [21] = "21:00", [22] = "22:00", [23] = "23:00" }
local subToPlantType = { GardenTomato = 3, GardenCucumber = 4, GardenRose = 5, GardenLily = 6, Ingredients = 7, Potatoes = 8, Cotton = 9 }
local plantTypeToSub = { [3] = "GardenTomato", [4] = "GardenCucumber", [5] = "GardenRose", [6] = "GardenLily", [7] = "Ingredients", [8] = "Potatoes", [9] = "Random" }
local DetectedMapSize = { [0.5] = "Large", [0.75] = "Medium", [1] = "Small" }
local setPlantType=""
local PlantToFind = "GardenPot2Remote"
local plantType = 9
local CoveredArea = {}
local plantRange = 5
local IngredientsNr = 76

function Create()
	if CurrentHour == 0 then							-- when placed at midnight set harvest hour to 11pm, otherwise it would say -1
		myHarvestHour = 23
	end
	Set(this,"HarvestHour", myHarvestHour)
	Set(this,"PlantType","Random")
	Set(this,"HarvestDone","No")
	Set(this,"DoorTimerDone","No")
	Set(this,"Range",5)
	Set(this,"LightSpawned",false)
	Set(this,"Tooltip","tooltip_init_Garden")
end

function FindStackNumbers()
	local newStack = Object.Spawn("Stack", this.Pos.x-1, this.Pos.y)
	for i = 1,2000 do
		Set(newStack,"Quantity",2)
		Set(newStack,"Contents",i)
		if newStack.Contents == "Ingredients" then
			IngredientsNr = i
			newStack.Delete()
			print("Stack Ingredients: "..IngredientsNr)
			break
		end
	end
end

function CalculateTimeWarpFactor(timePassed)
	if timeInit > initTimer then
	
		if timePerUpdate == nil then
			Now = math.floor(math.mod(World.TimeIndex,60))
			if not StartCountdown then
				if Now > StartingMinute then
					this.SubType = 1
					StartingMinute = Now
					StartCountdown = true
					this.Tooltip = {"tooltip_init_gardenpotA",StartingMinute,"A",StartingMinute+5,"B",Now,"C",0,"D" }
				end
			else
				timeTot=timeTot+timePassed
				this.Tooltip = {"tooltip_init_gardenpotB",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D" }
				if Now >= StartingMinute+5 then
					if timeTot > 9 then		-- the result should be around 9.99 for large map
						myTimeWarpFactor = 0.5
						this.SubType = 2
						this.Tooltip = {"tooltip_init_gardenpotC",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D","Large","E",myTimeWarpFactor,"F" }
					elseif timeTot > 6 then	-- the result should be around 6.66 for medium map
						myTimeWarpFactor = 0.75
						this.SubType = 3
						this.Tooltip = {"tooltip_init_gardenpotC",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D","Medium","E",myTimeWarpFactor,"F" }
					else					-- the result should be around 5 for small map
						myTimeWarpFactor = 1
						this.SubType = 4
						this.Tooltip = {"tooltip_init_gardenpotC",StartingMinute,"A",StartingMinute+5,"B",Now,"C",timeTot,"D","Small","E",myTimeWarpFactor,"F" }
					end
					timeTot = 0
					timePerUpdate = math.random(1,3) / myTimeWarpFactor
				end
			end
		else
			timeTot = timeTot+timePassed
			if timeTot > timePerUpdate then
				this.SubType = 0
				Set(this,"TimeWarp",myTimeWarpFactor)
				timePerUpdate = nil
			end
		end
	else
		timeInit = timeInit+timePassed
		Now = math.floor(math.mod(World.TimeIndex,60))
		if Now > 50 then
			timeInit = 0
			this.Tooltip = "tooltip_init_gardenpotA"
		else
			StartingMinute = Now
		end
	end
end

function toggleTypeClicked()
	plantType=plantType+1
	if plantType>9 then
		plantType=3
	end
	setPlantType = plantTypeToSub[plantType]
	Set(this,"PlantType",setPlantType)
	this.SetInterfaceCaption("toggleType", "Type: "..this.PlantType.."")
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.AgeHours ~= nil then
				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
					if plantType == 9 then setPlantType = plantTypeToSub[math.random(3,8)] end
					Set(myPlant,"PlantType",setPlantType)
					local subType = 1
					if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
					subType = subToPlantType[Get(myPlant,"PlantType")]
					Set(myPlant,"IsRipe", "Yes")
					elseif myPlant.AgeHours >= 18 then
						subType = subToPlantType[Get(myPlant,"PlantType")]
					elseif myPlant.AgeHours >=12 then
						subType = 2
					end
					if Get(myPlant,"SubType") ~= subType then
						Set(myPlant,"SubType", subType)
					end
					SetPlantTooltip(myPlant)
				end
			else
				InitPlant(myPlant,0.0)
			end
		end
	end
	myPlants = nil
	SetMyTooltip()
end

function togglePlantRangePlusClicked()
	if plantRange<=27 then
		if Covered==true then
			HideCoveredArea("Garden")
			Covered=false
		end
		plantRange=plantRange+2
		Set(this,"Range",plantRange)
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				if myPlant.AgeHours ~= nil then
					if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
						local subType = 1
						if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
						subType = subToPlantType[Get(myPlant,"PlantType")]
						Set(myPlant,"IsRipe", "Yes")
						elseif myPlant.AgeHours >= 18 then
							subType = subToPlantType[Get(myPlant,"PlantType")]
						elseif myPlant.AgeHours >=12 then
							subType = 2
						end
						if Get(myPlant,"SubType") ~= subType then
							Set(myPlant,"SubType", subType)
						end
						SetPlantTooltip(myPlant)
					end
				else
					InitPlant(myPlant,0.0)
				end
			end
		end
		myPlants = nil
		this.SetInterfaceCaption("togglePlantRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredPlantArea", "tooltip_button_ShowHideRange",this.Range,"X")
		this.SetInterfaceCaption("togglePlantRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.Range,"Garden")
		Covered=true
	end
	SetMyTooltip()
end

function toggleShowCoveredPlantAreaClicked()
	if Covered==true then
		HideCoveredArea("Garden")
		Covered=false
	else
		ShowCoveredArea(this.Range,"Garden")
		Covered=true
	end
end

function togglePlantRangeMinusClicked()
	if plantRange>=5 then
		if Covered==true then
			HideCoveredArea("Garden")
			Covered=false
		end
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				Set(myPlant,"SubType",9)
				Set(myPlant,"Tooltip","tooltip_GardenPotRemoteNotManaged")
			end
		end
		plantRange=plantRange-2
		Set(this,"Range",plantRange)
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				if myPlant.AgeHours ~= nil then
					if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
						local subType = 1
						if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
						subType = subToPlantType[Get(myPlant,"PlantType")]
						Set(myPlant,"IsRipe", "Yes")
						elseif myPlant.AgeHours >= 18 then
							subType = subToPlantType[Get(myPlant,"PlantType")]
						elseif myPlant.AgeHours >=12 then
							subType = 2
						end
						if Get(myPlant,"SubType") ~= subType then
							Set(myPlant,"SubType", subType)
						end
						SetPlantTooltip(myPlant)
					end
				else
					InitPlant(myPlant,0.0)
				end
			end
		end
		myPlants = nil
		this.SetInterfaceCaption("togglePlantRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredPlantArea", "tooltip_button_ShowHideRange",this.Range,"X")
		this.SetInterfaceCaption("togglePlantRangeMinus", "tooltip_button_changerangeminus")
		ShowCoveredArea(this.Range,"Garden")
		Covered=true
	end
	SetMyTooltip()
end

function toggleHarvestHourPlusClicked()
	myHarvestHour=myHarvestHour+1
	if myHarvestHour>23 then
		myHarvestHour=0
	end
	Set(this,"HarvestHour",myHarvestHour)
	this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
	if myHarvestHour > 0 then
		local newAge = 0
		if CurrentHour > myHarvestHour then
			newAge = CurrentHour-myHarvestHour
		else
			newAge = CurrentHour-myHarvestHour+24
		end
		if CurrentHour == myHarvestHour then
			newAge = 0
		end
		AgePlants(newAge)
	else
		ResetHarvestHour()
	end
	SetMyTooltip()
end

function toggleHarvestHourClicked()
	if myHarvestHour > 0 then
		myHarvestHour=0
	else
		myHarvestHour = CurrentHour
		Set(this,"HarvestDone","Yes")
		AgePlants(0.0)
	end
	Set(this,"HarvestHour",myHarvestHour)
	this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
	ResetHarvestHour()
	SetMyTooltip()
end

function toggleHarvestHourMinusClicked()
	myHarvestHour=myHarvestHour-1
	if myHarvestHour<0 then
		myHarvestHour=23
	end
	Set(this,"HarvestHour",myHarvestHour)
	this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
	if myHarvestHour > 0 then
		local newAge = 0
		if CurrentHour > myHarvestHour then
			newAge = CurrentHour-myHarvestHour
		else
			newAge = CurrentHour-myHarvestHour+24
		end
		if CurrentHour == myHarvestHour then
			newAge = 0
		end
		AgePlants(newAge)
	else
		ResetHarvestHour()
	end
	SetMyTooltip()
end

function AgePlants(theAge)
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.AgeHours ~= nil then
				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
					local subType = 1
					Set(myPlant,"AgeHours",theAge)
					Set(myPlant,"HarvestHour",myHarvestHour)
					if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
						subType = subToPlantType[Get(myPlant,"PlantType")]
						Set(myPlant,"IsRipe", "Yes")
						Set(myPlant,"IngredientsNr",IngredientsNr)
					elseif myPlant.AgeHours >= 18 then
						subType = subToPlantType[Get(myPlant,"PlantType")]
					elseif myPlant.AgeHours >= 12 then
						subType = 2
					end
					if Get(myPlant,"SubType") ~= subType then
						Set(myPlant,"SubType", subType)
					end
					SetPlantTooltip(myPlant)
				end
			else
				InitPlant(myPlant,theAge)
			end
		end
	end
	myPlants = nil
end

function ResetHarvestHour()
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.AgeHours ~= nil then
				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
					Set(myPlant,"HarvestHour",myHarvestHour)
					SetPlantTooltip(myPlant)
				end
			else
				InitPlant(myPlant,0.0)
			end
		end
	end
	myPlants = nil
end

function HarvestPlants()
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.AgeHours ~= nil then
				if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
					Set(myPlant,"IsRipe", "Yes")
					Set(myPlant,"NeedsTending","No")
					Set(myPlant,"NeedsWater","No")
					Set(myPlant,"NeedsFerti","No")
					Set(myPlant,"IsEmpty","No")
					Set(myPlant,"IsDead","No")
					Set(myPlant,"AgeHours",0.0)
					Set(myPlant,"AgeMinutes",0.0)
					Set(myPlant,"IngredientsNr",IngredientsNr)
					Set(myPlant,"SubType",subToPlantType[Get(myPlant,"PlantType")])
					Set(myPlant,"HarvestHour",myHarvestHour)
					Object.CreateJob(myPlant,"HarvestGardenPlant")
					myPlant.SeedJobIssued = nil
					myPlant.RemoveJobIssued = nil
					myPlant.TendJobIssued = nil
					myPlant.FertiJobIssued = nil
					myPlant.WaterJobIssued = nil
					myPlant.HarvestJobIssued = nil
					SetPlantTooltip(myPlant)
				end
			else
				InitPlant(myPlant,0.0)
			end
		end
	end
	myPlants = nil
end

function toggleResetJobsClicked()
	Set(this,"PlantsFound",0)
	local myPlants = Find(PlantToFind,this.Range)
	if next(myPlants) then
		for myPlant, dist in pairs(myPlants) do
			Set(this,"PlantsFound",this.PlantsFound+1)
			if myPlant.AgeHours ~= nil then
				if myPlant.IsRipe == "Yes" then
					Set(myPlant,"NeedsTending","No")
					Set(myPlant,"NeedsWater","No")
					Set(myPlant,"NeedsFerti","No")
					Set(myPlant,"IsEmpty","No")
					Set(myPlant,"IsDead","No")
					myPlant.TendJobIssued = nil
					myPlant.WaterJobIssued = nil
					myPlant.FertiJobIssued = nil
					myPlant.HarvestJobIssued = nil
				end
				if myPlant.NeedsTending == "Yes" then
					Set(myPlant,"NeedsFerti","No")
					Set(myPlant,"NeedsWater","No")
					myPlant.FertiJobIssued = nil
					myPlant.WaterJobIssued = nil
					myPlant.TendJobIssued = nil
				end
				if myPlant.NeedsFerti == "Yes" then
					Set(myPlant,"NeedsWater","No")
					Set(myPlant,"NeedsTending","No")
					myPlant.WaterJobIssued = nil
					myPlant.TendJobIssued = nil
					myPlant.FertiJobIssued = nil
				end
				if myPlant.NeedsWater == "Yes" then
					Set(myPlant,"NeedsTending","No")
					Set(myPlant,"NeedsFerti","No")
					myPlant.TendJobIssued = nil
					myPlant.FertiJobIssued = nil
					myPlant.WaterJobIssued = nil
				end
				if myPlant.IsDead == "Yes" then
					Set(myPlant,"IsEmpty","Yes")
					Set(myPlant,"NeedsTending","No")
					Set(myPlant,"NeedsWater","No")
					Set(myPlant,"NeedsFerti","No")
					myPlant.TendJobIssued = nil
					myPlant.WaterJobIssued = nil
					myPlant.FertiJobIssued = nil
					myPlant.SeedJobIssued = nil
					myPlant.RemoveJobIssued = nil
				end
				if myPlant.IsEmpty == "Yes" then
					Set(myPlant,"NeedsTending","No")
					Set(myPlant,"NeedsWater","No")
					Set(myPlant,"NeedsFerti","No")
					myPlant.TendJobIssued = nil
					myPlant.WaterJobIssued = nil
					myPlant.FertiJobIssued = nil
					myPlant.SeedJobIssued = nil
				end
				SetPlantTooltip(myPlant)
			else
				InitPlant(myPlant,0.0)
			end
		end
	end
	myPlants = nil
end

function InitPlant(thisPlant,thisAge)
--	local ourX = Get(thisPlant,"Pos.x")
--	local ourY = Get(thisPlant,"Pos.y")
--	local material = Object.GetMaterial( ourX, ourY )
--	if material ~= "Farmland" then
--		thisPlant.Tooltip = "tooltip_seeds_compost"
--		return
--	else
		if myHarvestHour == 0 then
			Set(thisPlant,"AgeHours",0.0)
			Set(thisPlant,"AgeMinutes",0.0)
		else
			Set(thisPlant,"AgeHours",thisAge)
			Set(thisPlant,"AgeMinutes",0.0)
		end
		local subType = 1
		if thisPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
			subType = subToPlantType[Get(thisPlant,"PlantType")]
			Set(thisPlant,"IsRipe", "Yes")
			Set(myPlant,"IngredientsNr",IngredientsNr)
		
		elseif thisPlant.AgeHours >= 18 then
			subType = subToPlantType[Get(thisPlant,"PlantType")]
		elseif thisPlant.AgeHours >= 12 then
			subType = 2
		end
		if Get(thisPlant,"SubType") ~= subType then
			Set(thisPlant,"SubType", subType)
		end
		Set(thisPlant,"NeedsTending","Yes")
		Set(thisPlant,"NeedsWater","No")
		Set(thisPlant,"NeedsFerti","No")
		Set(thisPlant,"IsRipe","No")
		Set(thisPlant,"IsEmpty","No")
		Set(thisPlant,"IsDead","No")
		Set(thisPlant,"RemainHarvest",math.random(3,6))			-- can be harvested 3-6 times before the plant is dead and a new seed must be planted
		Set(thisPlant,"HarvestHour",myHarvestHour)
		SetPlantTooltip(thisPlant)
--	end      
end

function Update( timePassed )
	if this.TimeWarp == nil then
		if World.TimeWarpFactor ~= nil then
			Set(this,"TimeWarp",World.TimeWarpFactor)
		else
			CalculateTimeWarpFactor(timePassed)
		end
		return
	end
	if timePerUpdate == nil then
		if this.LightSpawned == nil then Set(this,"LightSpawned",false) end
		FindStackNumbers()
		myHarvestHour = Get(this,"HarvestHour")
		myTimeWarpFactor = Get(this,"TimeWarp")
		plantRange = Get(this,"Range")
		Interface.AddComponent(this,"togglePlantRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredPlantArea", "Button", "tooltip_button_ShowHideRange",this.Range,"X")
		Interface.AddComponent(this,"togglePlantRangeMinus", "Button", "tooltip_button_changerangeminus")
		
		Interface.AddComponent(this,"CaptionSeparatorGarden1", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"toggleType", "Button", "Type: "..this.PlantType.."")
		Interface.AddComponent(this,"CaptionSeparatorGarden2", "Caption", "tooltip_separatorline")
			
		Interface.AddComponent(this,"toggleHarvestHourPlus", "Button", "tooltip_button_HarvestHourPlus")
		Interface.AddComponent(this,"toggleHarvestHour", "Button", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
		Interface.AddComponent(this,"toggleHarvestHourMinus", "Button", "tooltip_button_HarvestHourMinus")
		
		Interface.AddComponent(this,"CaptionSeparatorGarden3", "Caption", "tooltip_separatorline")
		Interface.AddComponent(this,"toggleResetJobs", "Button", "tooltip_button_ResetJobs")
	
		CurrentMinute = math.floor(math.mod(World.TimeIndex,60))
		if CurrentMinute > 45 then
			timePerUpdate = (60 - CurrentMinute ) / myTimeWarpFactor	-- next update is 1 minute after the next whole hour.
		elseif CurrentMinute > 30 then
			timePerUpdate = (45 - CurrentMinute ) / myTimeWarpFactor	-- next update is 15 minutes before the next whole hour.
		elseif CurrentMinute > 15 then
			timePerUpdate = (30 - CurrentMinute ) / myTimeWarpFactor	-- next update is 30 minutes past current hour.
		else
			timePerUpdate = (15 - CurrentMinute ) / myTimeWarpFactor	-- next update is 15 minutes past current hour.
		end
		
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				if myPlant.AgeHours == nil then
					InitPlant(myPlant,0.0)
				else
					if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
						SetPlantTooltip(myPlant)
					end
				end
				if myPlant.IsRipe == "Yes" then
					Set(myPlant,"IngredientsNr",IngredientsNr)
				end
			end
		end
		myPlants = nil
		
		SetMyTooltip()
	end
	
	timeTot=timeTot+timePassed
	if timeTot>timePerUpdate then
		timeTot=0
		
		if myTimeWarpFactor < 1 then
			if myTimeWarpFactor == 0.75 then
				timePerUpdate = 20
			elseif myTimeWarpFactor == 0.5 then
				timePerUpdate = 30
			end
		else
			timePerUpdate = 15
		end
		
		PreviousHour = CurrentHour
		CurrentHour = math.floor(math.mod(World.TimeIndex,1440) /60)
		CurrentMinute = math.floor(math.mod(World.TimeIndex,60))
		
		if CurrentHour == 20 and this.LightSpawned == false then
			LightOn()
			Set(this,"LightSpawned",true)
		elseif CurrentHour == 6 and this.LightSpawned == true then
			LightOff()
			Set(this,"LightSpawned",false)
		end
		
		
		-- forced harvest by game hour
		
		if CurrentHour == myHarvestHour and myHarvestHour > 0 then
			if this.HarvestDone == "No" then
				Set(this,"HarvestDone","Yes")
				HarvestPlants()
				SetMyTooltip()
				return
			end
		else
			if this.HarvestDone == "Yes" then
				Set(this,"HarvestDone","No")
			end
		end
		
		-- end harvest
		
		
		-- forced harvest by doortimer
		
		local hasPower = ( this.Triggered or 0 ) > 0
		if hasPower then
			if this.DoorTimerDone == "No" then
				myHarvestHour = CurrentHour
				Set(this,"HarvestHour",myHarvestHour)
				this.SetInterfaceCaption("toggleHarvestHour", "tooltip_button_HarvestHour",HourToHarvest[this.HarvestHour],"X")
				HarvestPlants()
				Set(this,"DoorTimerDone","Yes")
				SetMyTooltip()
				return
			end
		else
			if this.DoorTimerDone == "Yes" then
				Set(this,"DoorTimerDone","No")
			end
		end
		
		-- end doortimer
		
		
		Set(this,"PlantsFound",0)
		local myPlants = Find(PlantToFind,this.Range)
		if next(myPlants) then
			for myPlant, dist in pairs(myPlants) do
				Set(this,"PlantsFound",this.PlantsFound+1)
				
				if myPlant.AgeHours == nil then
					InitPlant(myPlant,0.0)
				else
					if myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
						if myHarvestHour == 0 then	-- myHarvestHour 0 = forced harvest disabled
							Set(myPlant,"AgeMinutes", myPlant.AgeMinutes+15)
							if myPlant.AgeMinutes >= 60 then
								Set(myPlant,"AgeHours", myPlant.AgeHours+1)
								Set(myPlant,"AgeMinutes",myPlant.AgeMinutes-60)
								if myPlant.AgeHours == 12 then myPlant.NeedsWater = "Yes" end
							end
						else	-- forced harvest at specific hour, stricter growing times
							Set(myPlant,"AgeMinutes", CurrentMinute)
							if PreviousHour~=CurrentHour then
								Set(myPlant,"AgeHours", myPlant.AgeHours+1)
								if myPlant.AgeHours == 12 then myPlant.NeedsWater = "Yes" end
							end
						end
						if myPlant.IsRipe == "No" and myPlant.IsEmpty == "No" and myPlant.IsDead == "No" then
							local subType = 1
							if myPlant.AgeHours >= maxAge and myHarvestHour == 0 then					-- plant life at 100% then harvest if myHarvestHour is disabled
							subType = subToPlantType[Get(myPlant,"PlantType")]
							Set(myPlant,"IsRipe", "Yes")
							elseif myPlant.AgeHours >= 18 then
								subType = subToPlantType[Get(myPlant,"PlantType")]
							elseif myPlant.AgeHours >=12 then
								subType = 2
							end
							if Get(myPlant,"SubType") ~= subType then
								Set(myPlant,"SubType", subType)
							end
						end
					end
					
					if myPlant.IsRipe == "Yes" and not myPlant.HarvestJobIssued then
						myPlant.HarvestJobIssued = true
						Object.CreateJob(myPlant,"HarvestGardenPlant")
						Set(this,"HarvestDone","Yes")
					elseif myPlant.IsEmpty == "Yes" and not myPlant.SeedJobIssued then
						myPlant.SeedJobIssued = true
						Object.CreateJob(myPlant,"PlantGardenSeed")
					elseif myPlant.IsDead == "Yes" and not myPlant.RemoveJobIssued then
						myPlant.RemoveJobIssued = true
						Object.CreateJob(myPlant,"RemoveDeadGardenPlant")
					elseif myPlant.NeedsTending == "Yes" and not myPlant.TendJobIssued then
						myPlant.TendJobIssued = true
						Object.CreateJob(myPlant,"TendGardenPlant")
					elseif myPlant.NeedsWater == "Yes" and not myPlant.WaterJobIssued then
						myPlant.WaterJobIssued = true
						Object.CreateJob(myPlant,"WaterGardenPlant")
					elseif myPlant.NeedsFerti == "Yes" and not myPlant.FertiJobIssued then
						myPlant.FertiJobIssued = true
						Object.CreateJob(myPlant,"FertilizeGardenPlant")
					end
					SetPlantTooltip(myPlant)
				end
			end
		end
		myPlants = nil
		SetMyTooltip()
	end
end

function SetMyTooltip()
	this.Tooltip = {"tooltip_PlantControl",HourToHarvest[this.HarvestHour],"A",this.PlantsFound,"B",this.Range,"C"}
end

function SetPlantTooltip(thePlant)
	if thePlant.IsDead =="Yes" then
		thePlant.Tooltip = "tooltip_PlantDead"
	elseif thePlant.IsEmpty =="Yes" then
		thePlant.Tooltip = "tooltip_PlantSeed"
	else
		thePlant.Tooltip = { "tooltip_PlantStatus",thePlant.PlantType,"A",thePlant.AgeHours,"B",thePlant.AgeMinutes,"C",HourToHarvest[thePlant.HarvestHour],"D", thePlant.NeedsTending,"E",thePlant.NeedsWater,"F",thePlant.NeedsFerti,"G",thePlant.IsRipe,"H", thePlant.RemainHarvest,"I"}
	end
end

function LightOn()
	local myLight = Object.Spawn("Light",this.Pos.x,this.Pos.y)
	Set(myLight,"Or.x",this.Or.x)
	Set(myLight,"Or.y",this.Or.y)
end

function LightOff()
	local myLight = this.GetNearbyObjects("Light",1)
	for thatLight, dist in pairs(myLight) do
		thatLight.Delete()
	end
	local myLight = this.GetNearbyObjects("LightOff",1)
	for thatLight, dist in pairs(myLight) do
		thatLight.Delete()
	end
	myLight = nil
end

function Find(theObject,theRange) -- returns targetobjects in a square around the object
	local Xmin=math.ceil(this.Pos.x-theRange/2)
	local Xmax=math.ceil(this.Pos.x+theRange/2)
	local Ymin=math.ceil(this.Pos.y-theRange/2)
	local Ymax=math.ceil(this.Pos.y+theRange/2)
	local ListOfObjects = this.GetNearbyObjects(theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	

function HideCoveredArea(theCoverType)
	for n,v in pairs(CoveredArea[theCoverType]) do
		CoveredArea[theCoverType][n].Delete()
	end
	CoveredArea[theCoverType] = nil
end

function ShowCoveredArea(theRange,theCoverType)
	local Xmin=math.ceil(this.Pos.x-theRange/2)
	local Xmax=math.ceil(this.Pos.x+theRange/2)
	local Ymin=math.ceil(this.Pos.y-theRange/2)
	local Ymax=math.ceil(this.Pos.y+theRange/2)
	local n=0
	CoveredArea[theCoverType] = {}
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmin,i)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymin)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmax,i)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymax)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredPlantArea"}
		n=n+1
	end
end
