
local HourToHarvest = { [0] = "disabled", [1] = "01:00", [2] = "02:00", [3] = "03:00", [4] = "04:00", [5] = "05:00", [6] = "06:00", [7] = "07:00", [8] = "08:00", [9] = "09:00", [10] = "10:00", [11] = "11:00", [12] = "12:00", [13] = "13:00", [14] = "14:00", [15] = "15:00", [16] = "16:00", [17] = "17:00", [18] = "18:00", [19] = "19:00", [20] = "20:00", [21] = "21:00", [22] = "22:00", [23] = "23:00" }

function Create()
	Object.SetProperty(this,"IngredientsNr",76)
	Object.SetProperty(this,"Tooltip","tooltip_need_GardenControl")
end

function JobComplete_PlantGardenSeed()
    Object.SetProperty(this,"IsEmpty", "No")
	if this.HarvestHour == 0 then	-- only set when no forced harvest time
		Object.SetProperty(this,"AgeHours", 0.0)
		Object.SetProperty(this,"AgeMinutes", 0.0)
	end
	Object.SetProperty(this,"SubType", 1)
	Object.SetProperty(this,"RemainHarvest", math.random(3,6))	-- Can be harvested 1~4 times
	if this.NeedsTending == "No" then
		Object.SetProperty(this,"NeedsTending", "Yes")
	end
	this.SeedJobIssued = nil
	SetPlantTooltip()
end

function JobComplete_TendGardenPlant()
    Object.SetProperty(this,"NeedsTending","No")
	Object.SetProperty(this,"NeedsWater","Yes" )
	this.TendJobIssued = nil
	SetPlantTooltip()
end

function JobComplete_WaterGardenPlant()
    Object.SetProperty(this,"NeedsWater","No")
	Object.SetProperty(this,"NeedsFerti","Yes" )
	this.WaterJobIssued = nil
	SetPlantTooltip()
end

function JobComplete_FertilizeGardenPlant()
    Object.SetProperty(this,"NeedsFerti","No")
	this.FertiJobIssued = nil
	SetPlantTooltip()
end

function JobComplete_RemoveDeadGardenPlant()
	Object.SetProperty(this,"IsEmpty", "Yes")
	Object.SetProperty(this,"IsDead", "No")
	Object.SetProperty(this,"SubType", 0)
	
	local name = Object.Spawn( "GardenDeadPlant", this.Pos.x, this.Pos.y )
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(name, velX, velY)
	
	this.RemoveJobIssued = nil
	SetPlantTooltip()
end

function JobComplete_HarvestGardenPlant()
	if this.HarvestHour == 0 then	-- only set when no forced harvest time
		Object.SetProperty(this,"AgeHours", 0.0)
		Object.SetProperty(this,"AgeMinutes", 0.0)
	end
	Object.SetProperty(this,"IsRipe","No")
	
	local outNum = math.random(20)
	if this.PlantType=="Potatoes" then
		local name = Object.Spawn("Stack", this.Pos.x, this.Pos.y )
		if this.IngredientsNr == nil then Object.SetProperty(this,"IngredientsNr",76) end
		Object.SetProperty(name, "Contents",this.IngredientsNr)	-- http://devwiki.introversion.co.uk/pa/index.php/ModSchema
	 	Object.SetProperty(name, "SubType",1)			
		Object.SetProperty(name, "Quantity",20)
		local velX = -1.0 + math.random() + math.random()
		local velY = -1.0 + math.random() + math.random()
		Object.ApplyVelocity(name, velX, velY)
	elseif this.PlantType=="Ingredients" then
		local name = Object.Spawn("Stack", this.Pos.x, this.Pos.y )
		if this.IngredientsNr == nil then Object.SetProperty(this,"IngredientsNr",76) end
		Object.SetProperty(name, "Contents",this.IngredientsNr)	-- http://devwiki.introversion.co.uk/pa/index.php/ModSchema
	 	Object.SetProperty(name, "SubType",0)			
		Object.SetProperty(name, "Quantity",20)			-- ingredients/potatoes always give stack of 20
		local velX = -1.0 + math.random() + math.random()
		local velY = -1.0 + math.random() + math.random()
		Object.ApplyVelocity(name, velX, velY)
	else
		for i = 1, outNum do				-- the number of outcome is between 1 and 20
		 	local name = Object.Spawn( this.PlantType, this.Pos.x, this.Pos.y )
			local velX = -1.0 + math.random() + math.random()
			local velY = -1.0 + math.random() + math.random()
			Object.ApplyVelocity(name, velX, velY)
		end
	end
	
	Object.SetProperty(this,"SubType", 1)
	if this.RemainHarvest == 0 then		-- harvest times before plant is dead and needs replacement
		Object.SetProperty(this,"IsDead", "Yes")
	else
		Object.SetProperty(this,"NeedsTending","Yes")
		if this.PlantType~="Potatoes" and this.PlantType~="Ingredients" then
			Object.SetProperty(this,"RemainHarvest", this.RemainHarvest-1)
		end
	end
	
	this.HarvestJobIssued = nil
	SetPlantTooltip()
end

function SetPlantTooltip()
	if this.IsDead =="Yes" then
		this.Tooltip = "tooltip_PlantDead"
	elseif this.IsEmpty =="Yes" then
		this.Tooltip = "tooltip_PlantSeed"
	else
		this.Tooltip = { "tooltip_PlantStatus",this.PlantType,"A",this.AgeHours,"B",this.AgeMinutes,"C",HourToHarvest[this.HarvestHour],"D", this.NeedsTending,"E",this.NeedsWater,"F",this.NeedsFerti,"G",this.IsRipe,"H", this.RemainHarvest,"I"}
	end
end
