
local timeTot=0
local Find = Object.GetNearbyObjects
local CompactGarbageContentsNr = 1
local MaxStackSize = 60														-- number is the InputCount specified in production.txt for this processor
local soundTimer = 0
local SoundMade = false
local GarbageProcessed = false

-- processor usually works as follows:
-- slot0: the input stuff
-- slot1: the processed stuff
-- slot2: the output stuff
-- slot3-7: not used... say what?

-- slot3-7: are now used to have 5 free slots where people can store their garbage at the same time (similar to a table in your workshop)
-- this way a trash compactor can handle 5 requests for storage, and you will only need one or perhaps two compactors in a big prison
-- garbage gets buffered from slots 3-7 to 'QueuedQuantity' when the script detects that SortedGarbage has been loaded into those slots
-- when 'QueuedQuantity' reaches MaxStackSize (InputCount), it will spawn a stack of 60 CompactGarbage in Slot0 for the processor
-- the game engine will then give the processor a job to produce the output stuff which gets moved to Exports


function Create()
	Set("QueuedQuantity",0)
end

function PutGarbageInQueue(SlotNr,ID)
	QueuedStack = Find("Stack",2)												-- check if there is a stack of garbage at specified slot
	if next(QueuedStack) then
		for thatQueuedStack, distance in pairs (QueuedStack) do	
			if thatQueuedStack.Id.u == ID and (thatQueuedStack.Contents == "SortedGarbage" or thatQueuedStack.Contents == "CompactGarbage") then
				Set("QueuedQuantity",Get("QueuedQuantity") + thatQueuedStack.Quantity)
				thatQueuedStack.CarrierId.i = -1
				thatQueuedStack.CarrierId.u = -1
				thatQueuedStack.Loaded = false
				Set("Slot"..SlotNr..".i",-1)
				Set("Slot"..SlotNr..".u",-1)
				thatQueuedStack.Delete()
			end
		end
	end
	QueuedStack = nil
	local MyGarbage = Find("SortedGarbage",2)
	if next(MyGarbage) then														-- check if there is just a bag of garbage instead of a stack
		for thatGarbage, distance in pairs (MyGarbage) do	
			if thatGarbage.Id.u == ID then
				Set("QueuedQuantity",Get("QueuedQuantity") + 1)
				thatGarbage.CarrierId.i = -1
				thatGarbage.CarrierId.u = -1
				thatGarbage.Loaded = false
				Set("Slot"..SlotNr..".i",-1)
				Set("Slot"..SlotNr..".u",-1)
				thatGarbage.Delete()
				MyGarbage = nil
			end
		end	
	end
	local MyGarbage = Find("CompactGarbage",2)
	if next(MyGarbage) then														-- check if there is just a bag of garbage instead of a stack
		for thatGarbage, distance in pairs (MyGarbage) do	
			if thatGarbage.Id.u == ID then
				Set("QueuedQuantity",Get("QueuedQuantity") + 1)
				thatGarbage.CarrierId.i = -1
				thatGarbage.CarrierId.u = -1
				thatGarbage.Loaded = false
				Set("Slot"..SlotNr..".i",-1)
				Set("Slot"..SlotNr..".u",-1)
				thatGarbage.Delete()
				MyGarbage = nil
			end
		end	
	end
end

function PutGarbageInProcessor()
	myCompactStack = Object.Spawn("Stack",this.Pos.x,this.Pos.y)
	myCompactStack.Contents = CompactGarbageContentsNr
	myCompactStack.Quantity = MaxStackSize
	myCompactStack.CarrierId.i = this.Id.i
	myCompactStack.CarrierId.u = this.Id.u
	myCompactStack.Loaded = true
	this.Slot0.i = myCompactStack.Id.i
	this.Slot0.u = myCompactStack.Id.u
	myCompactStack.Tooltip = "Ready to process"
	Set("QueuedQuantity",Get("QueuedQuantity") - MaxStackSize)
end
	
	
function Update( timePassed )
	if timePerUpdate == nil then												-- do once when the game loads or the object is placed on the map
	if this.QueuedQuantity == nil then Set("QueuedQuantity",0) end
		CompactGarbageContentsNr = 1											-- find out the contents number of CompactGarbage stack
		testStack = Object.Spawn("Stack",0,0)									-- since this bug still hasn't been fixed:
		Object.SetProperty(testStack,"Quantity",1)
		while not FoundContents do
			CompactGarbageContentsNr = CompactGarbageContentsNr+1
			Object.SetProperty(testStack,"Contents",CompactGarbageContentsNr)	-- stack contents is set by a number...
			if testStack.Contents == "CompactGarbage" then						-- ...but reads out as a string
				testStack.Delete()
				FoundContents = true
			end
		end
		timePerUpdate = 0.5
	end
	timeTot = timeTot + timePassed
	if timeTot>=timePerUpdate then
		timeTot=0

		if tonumber(this.Slot3.i) > -1 then											-- stack SortedGarbage coming from RecycleDesk
			PutGarbageInQueue(3,this.Slot3.u)
		elseif tonumber(this.Slot4.i) > -1 then										-- stack SortedGarbage coming from RecycleDesk
			PutGarbageInQueue(4,this.Slot4.u)
		elseif tonumber(this.Slot5.i) > -1 then										-- stack SortedGarbage coming from RecycleDesk
			PutGarbageInQueue(5,this.Slot5.u)
		elseif tonumber(this.Slot6.i) > -1 then										-- stack SortedGarbage coming from RecycleDesk
			PutGarbageInQueue(6,this.Slot6.u)
		elseif tonumber(this.Slot7.i) > -1 then										-- stack SortedGarbage coming from RecycleDesk
			PutGarbageInQueue(7,this.Slot7.u)
		end
		
		if Get("QueuedQuantity") >= MaxStackSize and GarbageProcessed == false and tonumber(this.JobId) == -1 and tonumber(this.Slot0.i) == -1 and tonumber(this.Slot2.i) == -1 then
			PutGarbageInProcessor()
			GarbageProcessed = true
		end
		
		if SoundMade == false and tonumber(this.JobId) > -1 and this.Timer > 1 then	-- check when the job gets active, this.Timer will grow to 13 (specified in production.txt)
			this.Sound("TrashCompactor","CompactTrash")								-- initiate sound once
			SoundMade = true
			soundTimer = 0
		end
		
		if SoundMade == true and soundTimer <= 12 then
			if this.SubType == 2 then this.SubType = 1 else this.SubType = 2 end	-- blink the statusLED
			soundTimer=soundTimer+0.5
		end
		
		if soundTimer > 12 then
			SoundMade = false
			soundTimer = 0
			this.SubType = 3														-- green statusLED
		end
		
		if tonumber(this.JobId) == -1 then this.Timer = 0 end
		
		if SoundMade == false then
			soundTimer = 0
			if tonumber(this.Slot0.i) == -1 and tonumber(this.Slot1.i) == -1 and tonumber(this.Slot2.i) > -1 then	-- the processor finished, garbage is ready for exports
				GarbageProcessed = false
				this.SubType = 3						-- green statusLED
			elseif Get("QueuedQuantity") > 0 then		-- trash compactor has some compacted trash
				this.SubType = 1						-- yellow statusLED
			elseif Get("QueuedQuantity") == 0 then		-- no garbage in queue, trash compactor is empty
				this.SubType = 0						-- dark red statusLED
			elseif tonumber(this.Slot0.i) > -1 and GarbageProcessed == false then	-- stack CompactGarbage coming from a dismantled TrashCompactor
				PutGarbageInQueue(0,this.Slot0.u)
			end
		end
		
		this.Tooltip={"tooltip_StatusLED",this.QueuedQuantity,"X"}
	end
end

    --Helper Functions
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
